#!/usr/bin/env python3

# Copyright 2021 Schpin
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


import rospy
import json
import sys
from schpin_msgs.srv import *

filename = sys.argv[1]

with open(filename) as fd:
    data = fd.read() 

    rospy.wait_for_service("/control/ctl")
    control_ctl = rospy.ServiceProxy('/control/ctl', BlobCtl)
    
    req = BlobCtlRequest()
    req.data = data
    res = control_ctl(req)
    print(res.res, res.error)

