// Copyright 2021 Schpin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.


#include <emlabcpp/quantity.h>

#pragma once

namespace em = emlabcpp;

namespace schpin
{

template < typename Tag, typename T, T Offset >
class protocol_offset : public em::quantity< protocol_offset< Tag, T, Offset >, T >
{
      public:
        static constexpr T offset = Offset;
        using em::quantity< protocol_offset< Tag, T, Offset >, T >::quantity;
};

}  // namespace schpin

template < typename Tag, typename T, T Offset >
struct std::numeric_limits< schpin::protocol_offset< Tag, T, Offset > >
  : std::numeric_limits< emlabcpp::quantity< schpin::protocol_offset< Tag, T, Offset >, T > >
{
};
