// Copyright 2021 Schpin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.


#include "emlabcpp/physical_quantity.h"
#include "schpin_lib/quantity.h"

#pragma once

// TODO: this is troublesoem the using...
namespace em = emlabcpp;

namespace schpin
{

struct occupancy : public em::quantity< occupancy, float >
{
        using quantity< occupancy, float >::quantity;

        static std::string get_unit()
        {
                return "o";  // ok, unit of this is %, but can we somehow implement 'scale' during
                             // print?
        }
};

enum class direction
{
        POS,
        NEG
};

}  // namespace schpin

template <>
struct std::numeric_limits< schpin::occupancy >
  : std::numeric_limits< em::quantity< schpin::occupancy, float > >
{
};

template <>
struct std::hash< schpin::occupancy > : std::hash< em::quantity< schpin::occupancy, float > >
{
};
